[//]: # (This is a comment)
[//]: # (Note: This file is present in both https://pagure.io/fedora-qa/blockerbugs and https://pagure.io/fedora-qa/blocker-review. Please try to keep them synchronized.)

## Fedora Blocker Review discussions
This is a place where Fedora contributors vote on Fedora release blockers. The process is described here:<br/>
https://fedoraproject.org/wiki/QA:SOP_blocker_bug_process<br/>
https://fedoraproject.org/wiki/QA:SOP_freeze_exception_bug_process<br/>
https://fedoraproject.org/wiki/Blocker_Bug_FAQ<br/>

It is meant to replace or complement Blocker Bug Meetings:<br/>
https://fedoraproject.org/wiki/QA:SOP_Blocker_Bug_Meeting

It is not intended that you navigate through this repo's tickets manually. Instead, visit:<br/>
https://qa.fedoraproject.org/blockerbugs/<br/>
then select a desired milestone and for each proposed blocker/freeze exception you'll see a **Vote** link displayed, which will direct you to the matching discussion ticket.

If a bug report is very complex and requires real-time communication instead of asynchronous ticket discussions, we'll tag the ticket with the [meeting tag](https://pagure.io/fedora-qa/blocker-review/issues?status=Open&tags=meeting) and the discussion will take place during a blocker bug meeting (see above) instead of here.

You can **Watch issues** in this repo, which will send you an email for every new proposed bug and every new comment in any ticket. If you wish to participate in blocker review discussions in general and not just in a single topic, this is the best way to subscribe.


### How to vote
Place a voting command on a separate line in the form of:<br/>
`TRACKER VOTE`

where `TRACKER` is one of these words (case-insensitive):

* `BetaBlocker`
* `FinalBlocker`
* `BetaFreezeException` (or `BetaFE`)
* `FinalFreezeException` (or `FinalFE`)
* `0Day`
* `PreviousRelease`

and `VOTE` is one of:

* `+1` (to vote in favor)
* `0` ([no strong feelings one way or the other](https://www.youtube.com/watch?v=ussCHoQttyQ) or to take your vote back)
* `-1` (to vote against)

Example:
```
BetaBlocker +1
```
If you want to cast several votes, you can use several separate lines (in one or more comments), or a single line:
```
BetaBlocker -1 BetaFE +1 FinalBlocker +1
```
You can swap the word order as well:
```
+1 FinalBlocker
```
Voting commands must not be mixed with arbitrary other words, this will **not** be counted:
```
BetaBlocker +1 for sure
```
If you vote for the same tracker multiple times, only your last vote is counted. For example, if you submit these three votes (in one or more comments):
```
BetaBlocker +1
BetaFE +1
BetaBlocker -1
```
then your resulting vote is `BetaBlocker -1 BetaFE +1`.

To take back your existing vote, simply re-vote it as `0`.

After submitting your vote, refresh the page and make sure it was counted properly.

To get more familiar with the bug review process and different tracker types, see:<br/>
https://fedoraproject.org/wiki/QA:SOP_blocker_bug_process


### Administrative commands
Members of the [fedora-qa](https://pagure.io/group/fedora-qa) Pagure group can issue administrative commands. Those commands are handled in the same way as voting commands, i.e. they need to be placed on a separate line and are case-insensitive. Those commands include:

`AGREED (Accepted|Rejected)TRACKER... [JUSTIFICATION]`

This will mark the specific tracker (one or more) as accepted or rejected. The justification is a free-form text that should then be copied to Bugzilla when setting appropriate blocker flags on the bug (this will happen automatically in the future, but currently it is the responsibility of the admin member). For example:
```
AGREED RejectedBetaBlocker AcceptedFinalBlocker This is not severe enough for Beta, but violates criterion X for Final.
```
Or:
```
AGREED RejectedBetaBlocker Happens only in very specific circumstances.
# a few comments later
AGREED AcceptedBetaFE We'll include the fix if it looks simple and safe.
```

A comment will be automatically added that will document the vote results at that particular point of time.

---

`REVOTE TRACKER...`

This will reset all votes for a specific tracker (one or more). When e.g. new information is discovered, this can be used to easily start a particular vote anew. Other trackers' votes will not be affected. For example:

```
REVOTE FinalBlocker FinalFE
```


### Usage notes
All commands are **case-insensitive**.

**Closed tickets** are not processed at all (neither for voting nor for administrative commands). If you want the bot to process a command, you need to re-open the ticket first.

Once you submit a command in a comment, the ticket should get immediately updated by *blockerbot* and the summary in the initial description should get updated. Simply **refresh the page** to verify that it was processed correctly.


### Help & contact
See contact information at:<br/>
https://fedoraproject.org/wiki/QA

Submit bugs and feature requests for this blocker-review discussion process at:<br/>
https://pagure.io/fedora-qa/blockerbugs
